'use strict';

exports.__esModule = true;
exports.combineValidators = combineValidators;

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj['default'] = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var _vendorTwitterText = require('./vendor/twitter-text');

var _vendorTwitterText2 = _interopRequireDefault(_vendorTwitterText);

var _regex = require('./regex');

var regex = _interopRequireWildcard(_regex);

var PRESETS = {
    // must use the non-global RegExp
    email: regex.EMAIL,
    // make a non-global URL RegExp
    url: new RegExp(_vendorTwitterText2['default'].regexen.extractUrl.source, 'i'),
    number: regex.NUMERIC_EN,
    'number eu': regex.NUMERIC_EU,
    int: regex.INT,
    uint: regex.UINT
},
    PRESET_KEYS = '"' + Object.keys(PRESETS).join('", "') + '"';

function combineValidators(validators, preset) {
    var rx;
    if (!preset) {
        return validators;
    }
    rx = PRESETS[preset];
    if (!rx) {
        throw new Error('Invalid validator preset: ' + preset + ', must be one of ' + PRESET_KEYS);
    } else if (!validators) {
        return rx;
    } else if (Array.isArray(validators)) {
        return validators.concat([rx]);
    } else {
        return [validators, rx];
    }
}