(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory(require("react"));
	else if(typeof define === 'function' && define.amd)
		define(["react"], factory);
	else if(typeof exports === 'object')
		exports["txregions"] = factory(require("react"));
	else
		root["txregions"] = factory(root["React"]);
})(this, function(__WEBPACK_EXTERNAL_MODULE_13__) {
return /******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};

/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {

/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId])
/******/ 			return installedModules[moduleId].exports;

/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			exports: {},
/******/ 			id: moduleId,
/******/ 			loaded: false
/******/ 		};

/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);

/******/ 		// Flag the module as loaded
/******/ 		module.loaded = true;

/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}


/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;

/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;

/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";

/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(0);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ (function(module, exports, __webpack_require__) {

	'use strict';

	exports.__esModule = true;

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

	var _markers = __webpack_require__(1);

	var _TxRegionsInput = __webpack_require__(8);

	var _TxRegionsInput2 = _interopRequireDefault(_TxRegionsInput);

	var markers = {
	    email: _markers.markEmail,
	    nonDigits: _markers.markNonDigits,
	    nonEmail: _markers.markNonEmail,
	    nonEnNumeric: _markers.markNonEnNumeric,
	    nonEuNumeric: _markers.markNonEuNumeric,
	    nonInt: _markers.markNonInt,
	    nonNumeric: _markers.markNonNumeric,
	    nonUint: _markers.markNonUint,
	    nonUrl: _markers.markNonUrl,
	    urls: _markers.markUrls
	};

	exports.markers = markers;
	exports.getInverseMarker = _markers.getInverseMarker;
	exports.getMatchMarker = _markers.getMatchMarker;
	exports['default'] = _TxRegionsInput2['default'];
	exports.classNames = _TxRegionsInput.classNames;

	var _validators = __webpack_require__(5);

	exports.validatorDefaults = _validators.validatorDefaults;

/***/ }),
/* 1 */
/***/ (function(module, exports, __webpack_require__) {

	'use strict';

	exports.__esModule = true;
	exports.getMatchMarker = getMatchMarker;
	exports.getInverseMarker = getInverseMarker;

	function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj['default'] = obj; return newObj; } }

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

	var _vendorTwitterText = __webpack_require__(6);

	var _vendorTwitterText2 = _interopRequireDefault(_vendorTwitterText);

	var _strings = __webpack_require__(2);

	var _regex = __webpack_require__(3);

	var regex = _interopRequireWildcard(_regex);

	var warnFn = (console.error || console.warn || console.log || function () {}).bind(console),
	    CLASS_NAME_WARNING = _strings.line('\n        Configured to mark text ranges, but a CSS class name to mark\n        them with is not found -- skipping'),
	    CLASS_NAME_ERROR_MSG = _strings.line('\n        Argument error: configuration for a className is not provided\n        -- use either a className as the second argument or provide an\n        options object: {classNameFromProps, classNameFromClassNames}');

	function getRegExp(value, options, defaultFlags) {
	    var flags;
	    if (value instanceof RegExp) {
	        return value;
	    } else {
	        // options.flags can be used to set flags on the RegExp
	        flags = options && options.flags;
	        return new RegExp('' + value, flags || defaultFlags);
	    }
	}

	function getClassNameFromOptions(options) {
	    var fromProps, fromClassNames, fallback;
	    if (typeof options === 'string') {
	        return {
	            className: options
	        };
	    }
	    fromProps = options.classNameFromProps;
	    fromClassNames = options.classNameFromClassNames;
	    fallback = options.fallbackClassName;
	    if (!fromProps && !fromClassNames && !fallback) {
	        return;
	    }
	    return {
	        getClassName: function getClassName(component, classNames) {
	            return fromProps && component.props[fromProps] || classNames[fromClassNames] || fallback;
	        }
	    };
	}

	function getMatchMarker(value, options) {
	    var rx, processOptsRv, classNameAlways, getClassName;
	    if (!value) {
	        return function () {};
	    }
	    // always use a RegExp
	    rx = getRegExp(value, options);
	    if (!rx.global) {
	        warnFn('If the global flag is not set, only the first match will be found');
	    }
	    if (!options) {
	        throw new Error(CLASS_NAME_ERROR_MSG);
	    }
	    processOptsRv = getClassNameFromOptions(options);
	    if (processOptsRv.className) {
	        classNameAlways = processOptsRv.className;
	    } else if (processOptsRv.getClassName) {
	        getClassName = processOptsRv.getClassName;
	    } else {
	        throw new Error(CLASS_NAME_ERROR_MSG);
	    }
	    return function markMatches(text, markRange, component, classNames) {
	        var className = classNameAlways || getClassName(component, classNames);
	        if (!className) {
	            warnFn(CLASS_NAME_WARNING);
	            return;
	        }
	        var m = rx.exec(text);
	        if (!m) {
	            return;
	        }
	        do {
	            markRange(m.index, rx.lastIndex, className);
	        } while (rx.global && (m = rx.exec(text)));
	    };
	}

	function getInverseMarker(value, options) {
	    var rx, processOptsRv, classNameAlways, getClassName;
	    if (!value) {
	        return function () {};
	    }
	    // always use a RegExp
	    rx = getRegExp(value, options);
	    if (!options) {
	        throw new Error(CLASS_NAME_ERROR_MSG);
	    }
	    processOptsRv = getClassNameFromOptions(options);
	    if (processOptsRv.className) {
	        classNameAlways = processOptsRv.className;
	    } else if (processOptsRv.getClassName) {
	        getClassName = processOptsRv.getClassName;
	    } else {
	        throw new Error(CLASS_NAME_ERROR_MSG);
	    }
	    return function markInverseMatches(text, markRange, component, classNames) {
	        var className = classNameAlways || getClassName(component, classNames);
	        if (!className) {
	            warnFn(CLASS_NAME_WARNING);
	            return;
	        }
	        var ci = 0,
	            m = rx.exec(text);
	        if (!m) {
	            markRange(0, text.length, className);
	            return;
	        }
	        do {
	            if (m.index !== ci) {
	                markRange(ci, m.index, className);
	            }
	            ci = m.index + m[0].length;
	        } while (rx.global && (m = rx.exec(text)));
	        if (ci < text.length) {
	            markRange(ci, text.length, className);
	        }
	    };
	}

	var markEmail = getMatchMarker(regex.EMAIL_GLOBAL, {
	    classNameFromProps: 'classEmail',
	    classNameFromClassNames: 'email'
	});

	exports.markEmail = markEmail;
	var markNonDigits = getMatchMarker(/\D+/g, {
	    classNameFromProps: 'classNonDigits',
	    classNameFromClassNames: 'nonDigits'
	});

	exports.markNonDigits = markNonDigits;
	var markNonEmail = getInverseMarker(regex.EMAIL, {
	    classNameFromProps: 'classNonEmail',
	    classNameFromClassNames: 'nonEmail'
	});

	exports.markNonEmail = markNonEmail;
	var markNonInt = getInverseMarker(regex.INT, {
	    classNameFromProps: 'classNonInt',
	    classNameFromClassNames: 'nonInt'
	});

	exports.markNonInt = markNonInt;
	var markNonEnNumeric = getInverseMarker(regex.NUMERIC_EN, {
	    classNameFromProps: 'classNonNumeric',
	    classNameFromClassNames: 'nonNumeric'
	});

	exports.markNonEnNumeric = markNonEnNumeric;
	var markNonNumeric = markNonEnNumeric;

	exports.markNonNumeric = markNonNumeric;
	var markNonEuNumeric = getInverseMarker(regex.NUMERIC_EU, {
	    classNameFromProps: 'classNonNumeric',
	    classNameFromClassNames: 'nonNumeric'
	});

	exports.markNonEuNumeric = markNonEuNumeric;
	var markNonUint = getInverseMarker(regex.UINT, {
	    classNameFromProps: 'classNonUint',
	    classNameFromClassNames: 'nonUint'
	});

	exports.markNonUint = markNonUint;
	var markNonUrl = getInverseMarker(_vendorTwitterText2['default'].regexen.extractUrl, {
	    classNameFromProps: 'classNonUrl',
	    classNameFromClassNames: 'nonUrl'
	});

	exports.markNonUrl = markNonUrl;
	var markUrls = getMatchMarker(_vendorTwitterText2['default'].regexen.extractUrl, {
	    classNameFromProps: 'classUrl',
	    classNameFromClassNames: 'url'
	});
	exports.markUrls = markUrls;

/***/ }),
/* 2 */
/***/ (function(module, exports) {

	'use strict';

	exports.__esModule = true;
	exports.line = line;
	exports.foldWhitespace = foldWhitespace;
	var KEY_CODES = Object.freeze({
	    ENTER: 13,
	    Z: 90
	});

	exports.KEY_CODES = KEY_CODES;

	function line(str, skipTrim) {
	    var s = str.replace(/\s+/g, ' ');
	    return skipTrim ? s : s.trim();
	}

	function foldWhitespace(str) {
	    return str.replace(/^\s+/, '') // no leading spaces
	    .replace(/\s/g, ' ') // only allow spaces, not tabs, new lines, etc
	    .replace(/ {3,}/g, '  '); // no more than 2 spaces anywhere
	}

/***/ }),
/* 3 */
/***/ (function(module, exports) {

	
	// EMAIl regex is a variation of the regex found here:
	// http://www.w3.org/TR/html5/forms.html#valid-e-mail-address
	'use strict';

	exports.__esModule = true;
	var EMAIL = /[a-zA-Z0-9.!#$%&'*+\/=?^_`{|}~-]+@[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+/;

	exports.EMAIL = EMAIL;
	var EMAIL_GLOBAL = new RegExp(EMAIL.source, 'g');

	exports.EMAIL_GLOBAL = EMAIL_GLOBAL;
	var NUMERIC_EN = /-?\d{1,3}(?:(?:,?\d\d\d)+|\d*)(?:\.\d+)?/;

	exports.NUMERIC_EN = NUMERIC_EN;
	var NUMERIC_EU = /-?\d{1,3}(?:(?:[\. ]?\d\d\d)+|\d*)(?:,\d+)?/;

	exports.NUMERIC_EU = NUMERIC_EU;
	var INT = /-?\d+/;

	exports.INT = INT;
	var UINT = /\d+/;
	exports.UINT = UINT;

/***/ }),
/* 4 */
/***/ (function(module, exports) {

	'use strict';

	exports.__esModule = true;
	exports.makeSelectionRange = makeSelectionRange;
	exports.filteredMap = filteredMap;
	exports.getIsRequiredChecker = getIsRequiredChecker;
	exports.numericPropCheck = numericPropCheck;
	exports.positiveNumericPropCheck = positiveNumericPropCheck;

	function makeSelectionRange(_x, _x2) {
	    var _again = true;

	    _function: while (_again) {
	        var node = _x,
	            textOffset = _x2;
	        _again = false;

	        var range, child, len, i;

	        if (textOffset > node.textContent.length) {
	            return;
	        }
	        if (node.nodeType === Node.TEXT_NODE) {
	            range = document.createRange();
	            range.setStart(node, textOffset);
	            return range;
	        }
	        if (node.nodeType === Node.ELEMENT_NODE) {
	            len = node.childNodes.length;
	            i = 0;
	            for (; i < len; i++) {
	                child = node.childNodes[i];
	                if (textOffset > child.textContent.length) {
	                    textOffset -= child.textContent.length;
	                } else {
	                    _x = child;
	                    _x2 = textOffset;
	                    _again = true;
	                    range = child = len = i = undefined;
	                    continue _function;
	                }
	            }
	        }
	    }
	}

	function filteredMap(arr, fn) {
	    var rv = [],
	        max = arr.length;
	    var i = 0,
	        v = undefined;
	    for (; i < max; i++) {
	        v = fn(arr[i]);
	        if (v != null) {
	            rv.push(v);
	        }
	    }
	    return rv;
	}

	function getIsRequiredChecker(checker) {
	    return function requiredChecker(props, propName) {
	        if (props[propName] == null) {
	            return new Error('Invalid prop: ' + propName + ' is required.');
	        }
	        return checker(props, propName);
	    };
	}

	function numericPropCheck(props, propName) {
	    var value = props[propName];
	    if (value == null) {
	        return;
	    }
	    if (isNaN(+value)) {
	        return new Error('Invalid: Number or numeric String required');
	    }
	}

	numericPropCheck.isRequired = getIsRequiredChecker(numericPropCheck);

	function positiveNumericPropCheck(props, propName) {
	    var value = props[propName];
	    if (value == null) {
	        return;
	    }
	    if (isNaN(+value)) {
	        return new Error('Invalid: ' + propName + ' must be a Number or numeric String');
	    } else if (+value < 1) {
	        return new Error('Invalid: ' + propName + ' must be greater than 1');
	    }
	}

	positiveNumericPropCheck.isRequired = getIsRequiredChecker(positiveNumericPropCheck);

/***/ }),
/* 5 */
/***/ (function(module, exports, __webpack_require__) {

	'use strict';

	exports.__esModule = true;
	exports.validatorsPropCheck = validatorsPropCheck;
	exports.makeValidators = makeValidators;

	function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

	var _markers = __webpack_require__(1);

	var _strings = __webpack_require__(2);

	var _utils = __webpack_require__(4);

	var validatorDefaults = {
	    key: 'general',
	    mark: true,
	    className: 'txr-invalid'
	};

	exports.validatorDefaults = validatorDefaults;
	var PROP_TYPE_ERR_MESSAGE = _strings.line('\n    Invalid "validators" prop, must be either a RegExp, function, config\n    Object, or an Array of these. The config Object can have the optional\n    property \'className: <string>\' which would specify the className the\n    validators the Object defines would mark characters with. The config Object\n    may also have a \'mark: <boolean>\' property which, if false, will prevent the\n    validators specified by the config object from marking invalid text with a\n    className. The config Object may have an arbitrary number of key/value pairs\n    where the value should be a RegExp (must be a full-match) or a function\n    returning a boolean (true indicates a failure) and the key is the string\n    added to the [data-violations] attribute on the wrapping <div> if the RegExp\n    or function fail. Note: if a function returns a value other than a boolean\n    the value is converted to a string and added to the [data-violations]\n    attribute.');

	function propValueCheck(value) {
	    if (!value) {
	        return 'Invalid value: ' + value;
	    }
	    if (typeof value === 'function') {
	        return;
	    }
	    if (value instanceof RegExp) {
	        return;
	    }
	    if (Array.isArray(value)) {
	        return value.map(propValueCheck).filter(Boolean).join('; ');
	    }
	    if (typeof value !== 'object') {
	        return 'Invalid value: ' + value;
	    }
	    if ('mark' in value && typeof value.mark !== 'boolean') {
	        return 'The "mark" property must be a boolean.';
	    }
	    if ('className' in value && typeof value.className !== 'string') {
	        return 'The "className" property must be a string.';
	    }
	    return Object.keys(value).map(function (key) {
	        if (key !== 'className' && key !== 'mark' && !(value[key] instanceof RegExp) && typeof value[key] !== 'function') {
	            return 'Invalid property, ' + key + ' must be a RegExp or function.';
	        };
	    }).filter(Boolean).join('; ');
	}

	function validatorsPropCheck(props, propName) {
	    var value = props[propName];
	    if (value == null) {
	        return;
	    }
	    var msgs = propValueCheck(value);
	    if (msgs) {
	        return new Error(msgs + ' - ' + PROP_TYPE_ERR_MESSAGE);
	    }
	}

	validatorsPropCheck.isRequired = _utils.getIsRequiredChecker(validatorsPropCheck);

	// Different forms the validator definition can take (in JSX):
	//
	//         validators={/\d+/}
	//         validators={myTestFn}
	//         validators={{digits: /\d+/, mark: false}}
	//         validators={{upperLetters: /[A-Z]+/, lowerLetters: /[a-z]+/}}
	//         validators={[
	//             /\d+/,
	//             myTestFn,
	//             {testKey: myTestFn},
	//             {digits: /\d+/, mark: false},
	//             {upperLetters: /[A-Z]+/, lowerLetters: /[a-z]+/, className: 'invalid'},
	//         ]}

	function makeValidators(value, invalidClassName) {
	    invalidClassName = invalidClassName || validatorDefaults.className;
	    switch (true) {
	        case !value:
	            throw new Error('Invalid validator value');

	        case value instanceof RegExp:
	            return new RxValidator(value, invalidClassName);

	        case typeof value === 'function':
	            return new FnValidator(value);

	        case Array.isArray(value):
	            var validatorArr = value.map(function (item) {
	                return makeValidators(item, invalidClassName);
	            });
	            return new ValidatorSeries(validatorArr);

	        case typeof value === 'object':
	            var mark = value.mark,
	                className = value.className || invalidClassName,
	                keys = Object.keys(value).filter(function (key) {
	                return key !== 'mark' && key !== 'className';
	            }),
	                validators = keys.map(function (key) {
	                var v = value[key];
	                if (v instanceof RegExp) {
	                    return new RxValidator(v, className, key, mark);
	                } else if (typeof v === 'function') {
	                    return new FnValidator(v, key);
	                } else {
	                    throw new Error('Invalid validator value');
	                }
	            });
	            return new ValidatorSeries(validators);
	    }
	}

	var RxValidator = (function () {
	    function RxValidator(rx) {
	        var className = arguments.length <= 1 || arguments[1] === undefined ? validatorDefaults.className : arguments[1];
	        var key = arguments.length <= 2 || arguments[2] === undefined ? validatorDefaults.key : arguments[2];
	        var mark = arguments.length <= 3 || arguments[3] === undefined ? validatorDefaults.mark : arguments[3];

	        _classCallCheck(this, RxValidator);

	        this.rx = rx;
	        this.key = key;
	        if (mark) {
	            this.marker = _markers.getInverseMarker(this.rx, className);
	        } else {
	            this.marker = undefined;
	        }
	    }

	    RxValidator.prototype.exec = function exec(text) {
	        var markRange = arguments.length <= 1 || arguments[1] === undefined ? undefined : arguments[1];

	        var ok = !text.replace(this.rx, '').length;
	        if (ok) {
	            return;
	        }
	        if (this.marker && markRange) {
	            this.marker(text, markRange);
	        }
	        return this.key;
	    };

	    return RxValidator;
	})();

	var FnValidator = (function () {
	    function FnValidator(fn) {
	        var key = arguments.length <= 1 || arguments[1] === undefined ? validatorDefaults.key : arguments[1];

	        _classCallCheck(this, FnValidator);

	        this.fn = fn;
	        this.key = key;
	    }

	    FnValidator.prototype.exec = function exec(text, markRange) {
	        var rv = this.fn(text, markRange);
	        if (rv) {
	            return typeof rv === 'boolean' ? this.key : '' + rv;
	        }
	    };

	    return FnValidator;
	})();

	var ValidatorSeries = (function () {
	    function ValidatorSeries(validators) {
	        _classCallCheck(this, ValidatorSeries);

	        this.validators = validators;
	    }

	    ValidatorSeries.prototype.exec = function exec(text, markRange) {
	        return _utils.filteredMap(this.validators, function (v) {
	            return v.exec(text, markRange);
	        }).join(' ');
	    };

	    return ValidatorSeries;
	})();

/***/ }),
/* 6 */
/***/ (function(module, exports) {

	/*
	A subset and slight variation of the code found here:
	https://github.com/twitter/twitter-text/blob/master/js/twitter-text.js

	Which is under this license:
	http://www.apache.org/licenses/LICENSE-2.0
	*/

	"use strict";

	exports.__esModule = true;
	(function () {
	  if (typeof twttr === "undefined" || twttr === null) {
	    var twttr = {};
	  }

	  twttr.txt = {};
	  twttr.txt.regexen = {};

	  // Builds a RegExp
	  function regexSupplant(regex, flags) {
	    flags = flags || "";
	    if (typeof regex !== "string") {
	      if (regex.global && flags.indexOf("g") < 0) {
	        flags += "g";
	      }
	      if (regex.ignoreCase && flags.indexOf("i") < 0) {
	        flags += "i";
	      }
	      if (regex.multiline && flags.indexOf("m") < 0) {
	        flags += "m";
	      }

	      regex = regex.source;
	    }

	    return new RegExp(regex.replace(/#\{(\w+)\}/g, function (match, name) {
	      var newRegex = twttr.txt.regexen[name] || "";
	      if (typeof newRegex !== "string") {
	        newRegex = newRegex.source;
	      }
	      return newRegex;
	    }), flags);
	  }

	  twttr.txt.regexSupplant = regexSupplant;

	  // simple string interpolation
	  function stringSupplant(str, values) {
	    return str.replace(/#\{(\w+)\}/g, function (match, name) {
	      return values[name] || "";
	    });
	  }

	  twttr.txt.stringSupplant = stringSupplant;

	  function addCharsToCharClass(charClass, start, end) {
	    var s = String.fromCharCode(start);
	    if (end !== start) {
	      s += "-" + String.fromCharCode(end);
	    }
	    charClass.push(s);
	    return charClass;
	  }

	  twttr.txt.addCharsToCharClass = addCharsToCharClass;

	  // Space is more than %20, U+3000 for example is the full-width space used with Kanji. Provide a short-hand
	  // to access both the list of characters and a pattern suitible for use with String#split
	  // Taken from: ActiveSupport::Multibyte::Handlers::UTF8Handler::UNICODE_WHITESPACE
	  var fromCode = String.fromCharCode;
	  var UNICODE_SPACES = [fromCode(0x0020), // White_Space # Zs       SPACE
	  fromCode(0x0085), // White_Space # Cc       <control-0085>
	  fromCode(0x00A0), // White_Space # Zs       NO-BREAK SPACE
	  fromCode(0x1680), // White_Space # Zs       OGHAM SPACE MARK
	  fromCode(0x180E), // White_Space # Zs       MONGOLIAN VOWEL SEPARATOR
	  fromCode(0x2028), // White_Space # Zl       LINE SEPARATOR
	  fromCode(0x2029), // White_Space # Zp       PARAGRAPH SEPARATOR
	  fromCode(0x202F), // White_Space # Zs       NARROW NO-BREAK SPACE
	  fromCode(0x205F), // White_Space # Zs       MEDIUM MATHEMATICAL SPACE
	  fromCode(0x3000) // White_Space # Zs       IDEOGRAPHIC SPACE
	  ];
	  addCharsToCharClass(UNICODE_SPACES, 0x009, 0x00D); // White_Space # Cc   [5] <control-0009>..<control-000D>
	  addCharsToCharClass(UNICODE_SPACES, 0x2000, 0x200A); // White_Space # Zs  [11] EN QUAD..HAIR SPACE

	  var INVALID_CHARS = [fromCode(0xFFFE), fromCode(0xFEFF), // BOM
	  fromCode(0xFFFF) // Special
	  ];
	  addCharsToCharClass(INVALID_CHARS, 0x202A, 0x202E); // Directional change

	  twttr.txt.regexen.spaces_group = regexSupplant(UNICODE_SPACES.join(""));
	  twttr.txt.regexen.spaces = regexSupplant("[" + UNICODE_SPACES.join("") + "]");
	  twttr.txt.regexen.invalid_chars_group = regexSupplant(INVALID_CHARS.join(""));
	  twttr.txt.regexen.punct = /\!'#%&'\(\)*\+,\\\-\.\/:;<=>\?@\[\]\^_{|}~\$/;

	  var latinAccentChars = [];
	  // Latin accented characters (subtracted 0xD7 from the range, it's a confusable multiplication sign. Looks like "x")
	  addCharsToCharClass(latinAccentChars, 0x00c0, 0x00d6);
	  addCharsToCharClass(latinAccentChars, 0x00d8, 0x00f6);
	  addCharsToCharClass(latinAccentChars, 0x00f8, 0x00ff);
	  // Latin Extended A and B
	  addCharsToCharClass(latinAccentChars, 0x0100, 0x024f);
	  // assorted IPA Extensions
	  addCharsToCharClass(latinAccentChars, 0x0253, 0x0254);
	  addCharsToCharClass(latinAccentChars, 0x0256, 0x0257);
	  addCharsToCharClass(latinAccentChars, 0x0259, 0x0259);
	  addCharsToCharClass(latinAccentChars, 0x025b, 0x025b);
	  addCharsToCharClass(latinAccentChars, 0x0263, 0x0263);
	  addCharsToCharClass(latinAccentChars, 0x0268, 0x0268);
	  addCharsToCharClass(latinAccentChars, 0x026f, 0x026f);
	  addCharsToCharClass(latinAccentChars, 0x0272, 0x0272);
	  addCharsToCharClass(latinAccentChars, 0x0289, 0x0289);
	  addCharsToCharClass(latinAccentChars, 0x028b, 0x028b);
	  // Okina for Hawaiian (it *is* a letter character)
	  addCharsToCharClass(latinAccentChars, 0x02bb, 0x02bb);
	  // Combining diacritics
	  addCharsToCharClass(latinAccentChars, 0x0300, 0x036f);
	  // Latin Extended Additional
	  addCharsToCharClass(latinAccentChars, 0x1e00, 0x1eff);
	  twttr.txt.regexen.latinAccentChars = regexSupplant(latinAccentChars.join(""));

	  // URL related regex collection
	  twttr.txt.regexen.validUrlPrecedingChars = regexSupplant(/(?:[^A-Za-z0-9@＠$#＃#{invalid_chars_group}]|^)/);
	  twttr.txt.regexen.invalidUrlWithoutProtocolPrecedingChars = /[-_.\/]$/;
	  twttr.txt.regexen.invalidDomainChars = stringSupplant("#{punct}#{spaces_group}#{invalid_chars_group}", twttr.txt.regexen);
	  twttr.txt.regexen.validDomainChars = regexSupplant(/[^#{invalidDomainChars}]/);
	  twttr.txt.regexen.validSubdomain = regexSupplant(/(?:(?:#{validDomainChars}(?:[_-]|#{validDomainChars})*)?#{validDomainChars}\.)/);
	  twttr.txt.regexen.validDomainName = regexSupplant(/(?:(?:#{validDomainChars}(?:-|#{validDomainChars})*)?#{validDomainChars}\.)/);
	  twttr.txt.regexen.validGTLD = regexSupplant(RegExp('(?:(?:' + 'abb|abbott|abogado|academy|accenture|accountant|accountants|aco|active|actor|ads|adult|aeg|aero|' + 'afl|agency|aig|airforce|airtel|allfinanz|alsace|amsterdam|android|apartments|app|aquarelle|' + 'archi|army|arpa|asia|associates|attorney|auction|audio|auto|autos|axa|azure|band|bank|bar|' + 'barcelona|barclaycard|barclays|bargains|bauhaus|bayern|bbc|bbva|bcn|beer|bentley|berlin|best|' + 'bet|bharti|bible|bid|bike|bing|bingo|bio|biz|black|blackfriday|bloomberg|blue|bmw|bnl|' + 'bnpparibas|boats|bond|boo|boots|boutique|bradesco|bridgestone|broker|brother|brussels|budapest|' + 'build|builders|business|buzz|bzh|cab|cafe|cal|camera|camp|cancerresearch|canon|capetown|capital|' + 'caravan|cards|care|career|careers|cars|cartier|casa|cash|casino|cat|catering|cba|cbn|ceb|center|' + 'ceo|cern|cfa|cfd|chanel|channel|chat|cheap|chloe|christmas|chrome|church|cisco|citic|city|' + 'claims|cleaning|click|clinic|clothing|cloud|club|coach|codes|coffee|college|cologne|com|' + 'commbank|community|company|computer|condos|construction|consulting|contractors|cooking|cool|' + 'coop|corsica|country|coupons|courses|credit|creditcard|cricket|crown|crs|cruises|cuisinella|' + 'cymru|cyou|dabur|dad|dance|date|dating|datsun|day|dclk|deals|degree|delivery|delta|democrat|' + 'dental|dentist|desi|design|dev|diamonds|diet|digital|direct|directory|discount|dnp|docs|dog|' + 'doha|domains|doosan|download|drive|durban|dvag|earth|eat|edu|education|email|emerck|energy|' + 'engineer|engineering|enterprises|epson|equipment|erni|esq|estate|eurovision|eus|events|everbank|' + 'exchange|expert|exposed|express|fage|fail|faith|family|fan|fans|farm|fashion|feedback|film|' + 'finance|financial|firmdale|fish|fishing|fit|fitness|flights|florist|flowers|flsmidth|fly|foo|' + 'football|forex|forsale|forum|foundation|frl|frogans|fund|furniture|futbol|fyi|gal|gallery|game|' + 'garden|gbiz|gdn|gent|genting|ggee|gift|gifts|gives|giving|glass|gle|global|globo|gmail|gmo|gmx|' + 'gold|goldpoint|golf|goo|goog|google|gop|gov|graphics|gratis|green|gripe|group|guge|guide|' + 'guitars|guru|hamburg|hangout|haus|healthcare|help|here|hermes|hiphop|hitachi|hiv|hockey|' + 'holdings|holiday|homedepot|homes|honda|horse|host|hosting|hoteles|hotmail|house|how|hsbc|ibm|' + 'icbc|ice|icu|ifm|iinet|immo|immobilien|industries|infiniti|info|ing|ink|institute|insure|int|' + 'international|investments|ipiranga|irish|ist|istanbul|itau|iwc|java|jcb|jetzt|jewelry|jlc|jll|' + 'jobs|joburg|jprs|juegos|kaufen|kddi|kim|kitchen|kiwi|koeln|komatsu|krd|kred|kyoto|lacaixa|' + 'lancaster|land|lasalle|lat|latrobe|law|lawyer|lds|lease|leclerc|legal|lexus|lgbt|liaison|lidl|' + 'life|lighting|limited|limo|link|live|lixil|loan|loans|lol|london|lotte|lotto|love|ltda|lupin|' + 'luxe|luxury|madrid|maif|maison|man|management|mango|market|marketing|markets|marriott|mba|media|' + 'meet|melbourne|meme|memorial|men|menu|miami|microsoft|mil|mini|mma|mobi|moda|moe|mom|monash|' + 'money|montblanc|mormon|mortgage|moscow|motorcycles|mov|movie|movistar|mtn|mtpc|museum|nadex|' + 'nagoya|name|navy|nec|net|netbank|network|neustar|new|news|nexus|ngo|nhk|nico|ninja|nissan|nokia|' + 'nra|nrw|ntt|nyc|office|okinawa|omega|one|ong|onl|online|ooo|oracle|orange|org|organic|osaka|' + 'otsuka|ovh|page|panerai|paris|partners|parts|party|pet|pharmacy|philips|photo|photography|' + 'photos|physio|piaget|pics|pictet|pictures|pink|pizza|place|play|plumbing|plus|pohl|poker|porn|' + 'post|praxi|press|pro|prod|productions|prof|properties|property|pub|qpon|quebec|racing|realtor|' + 'realty|recipes|red|redstone|rehab|reise|reisen|reit|ren|rent|rentals|repair|report|republican|' + 'rest|restaurant|review|reviews|rich|ricoh|rio|rip|rocks|rodeo|rsvp|ruhr|run|ryukyu|saarland|' + 'sakura|sale|samsung|sandvik|sandvikcoromant|sanofi|sap|sarl|saxo|sca|scb|schmidt|scholarships|' + 'school|schule|schwarz|science|scor|scot|seat|seek|sener|services|sew|sex|sexy|shiksha|shoes|' + 'show|shriram|singles|site|ski|sky|skype|sncf|soccer|social|software|sohu|solar|solutions|sony|' + 'soy|space|spiegel|spreadbetting|srl|starhub|statoil|studio|study|style|sucks|supplies|supply|' + 'support|surf|surgery|suzuki|swatch|swiss|sydney|systems|taipei|tatamotors|tatar|tattoo|tax|taxi|' + 'team|tech|technology|tel|telefonica|temasek|tennis|thd|theater|tickets|tienda|tips|tires|tirol|' + 'today|tokyo|tools|top|toray|toshiba|tours|town|toyota|toys|trade|trading|training|travel|trust|' + 'tui|ubs|university|uno|uol|vacations|vegas|ventures|vermögensberater|vermögensberatung|' + 'versicherung|vet|viajes|video|villas|vin|vision|vista|vistaprint|vlaanderen|vodka|vote|voting|' + 'voto|voyage|wales|walter|wang|watch|webcam|website|wed|wedding|weir|whoswho|wien|wiki|' + 'williamhill|win|windows|wine|wme|work|works|world|wtc|wtf|xbox|xerox|xin|xperia|xxx|xyz|yachts|' + 'yandex|yodobashi|yoga|yokohama|youtube|zip|zone|zuerich|дети|ком|москва|онлайн|орг|рус|сайт|קום|' + 'بازار|شبكة|كوم|موقع|कॉम|नेट|संगठन|คอม|みんな|グーグル|コム|世界|中信|中文网|企业|佛山|信息|健康|八卦|公司|公益|商城|商店|商标|在线|大拿|' + '娱乐|工行|广东|慈善|我爱你|手机|政务|政府|新闻|时尚|机构|淡马锡|游戏|点看|移动|组织机构|网址|网店|网络|谷歌|集团|飞利浦|餐厅|닷넷|닷컴|삼성|onion' + ')(?=[^0-9a-zA-Z@]|$))'));
	  twttr.txt.regexen.validCCTLD = regexSupplant(RegExp('(?:(?:' + 'ac|ad|ae|af|ag|ai|al|am|an|ao|aq|ar|as|at|au|aw|ax|az|ba|bb|bd|be|bf|bg|bh|bi|bj|bl|bm|bn|bo|bq|' + 'br|bs|bt|bv|bw|by|bz|ca|cc|cd|cf|cg|ch|ci|ck|cl|cm|cn|co|cr|cu|cv|cw|cx|cy|cz|de|dj|dk|dm|do|dz|' + 'ec|ee|eg|eh|er|es|et|eu|fi|fj|fk|fm|fo|fr|ga|gb|gd|ge|gf|gg|gh|gi|gl|gm|gn|gp|gq|gr|gs|gt|gu|gw|' + 'gy|hk|hm|hn|hr|ht|hu|id|ie|il|im|in|io|iq|ir|is|it|je|jm|jo|jp|ke|kg|kh|ki|km|kn|kp|kr|kw|ky|kz|' + 'la|lb|lc|li|lk|lr|ls|lt|lu|lv|ly|ma|mc|md|me|mf|mg|mh|mk|ml|mm|mn|mo|mp|mq|mr|ms|mt|mu|mv|mw|mx|' + 'my|mz|na|nc|ne|nf|ng|ni|nl|no|np|nr|nu|nz|om|pa|pe|pf|pg|ph|pk|pl|pm|pn|pr|ps|pt|pw|py|qa|re|ro|' + 'rs|ru|rw|sa|sb|sc|sd|se|sg|sh|si|sj|sk|sl|sm|sn|so|sr|ss|st|su|sv|sx|sy|sz|tc|td|tf|tg|th|tj|tk|' + 'tl|tm|tn|to|tp|tr|tt|tv|tw|tz|ua|ug|uk|um|us|uy|uz|va|vc|ve|vg|vi|vn|vu|wf|ws|ye|yt|za|zm|zw|ελ|' + 'бел|мкд|мон|рф|срб|укр|қаз|հայ|الاردن|الجزائر|السعودية|المغرب|امارات|ایران|بھارت|تونس|سودان|' + 'سورية|عراق|عمان|فلسطين|قطر|مصر|مليسيا|پاکستان|भारत|বাংলা|ভারত|ਭਾਰਤ|ભારત|இந்தியா|இலங்கை|' + 'சிங்கப்பூர்|భారత్|ලංකා|ไทย|გე|中国|中國|台湾|台灣|新加坡|澳門|香港|한국' + ')(?=[^0-9a-zA-Z@]|$))'));
	  twttr.txt.regexen.validPunycode = regexSupplant(/(?:xn--[0-9a-z]+)/);
	  twttr.txt.regexen.validDomain = regexSupplant(/(?:#{validSubdomain}*#{validDomainName}(?:#{validGTLD}|#{validCCTLD}|#{validPunycode}))/);
	  twttr.txt.regexen.validAsciiDomain = regexSupplant(/(?:(?:[\-a-z0-9#{latinAccentChars}]+)\.)+(?:#{validGTLD}|#{validCCTLD}|#{validPunycode})/gi);

	  twttr.txt.regexen.validPortNumber = regexSupplant(/[0-9]+/);

	  // NOTE: To resolve an issue with an invalid RegExp error when transpiling
	  // with babel and webpack, the string in the following commented out line is
	  // replaced with a String created via `String.fromCharCode(...)`.
	  // twttr.txt.regexen.cyrillicLettersAndMarks = regexSupplant("\u0400-\u04ff");
	  twttr.txt.regexen.cyrillicLettersAndMarks = regexSupplant(String.fromCharCode(1024) + "-" + String.fromCharCode(1279));
	  twttr.txt.regexen.validGeneralUrlPathChars = regexSupplant(/[a-z#{cyrillicLettersAndMarks}0-9!\*';:=\+,\.\$\/%#\[\]\-_~@\|&#{latinAccentChars}]/i);
	  // Allow URL paths to contain up to two nested levels of balanced parens
	  //  1. Used in Wikipedia URLs like /Primer_(film)
	  //  2. Used in IIS sessions like /S(dfd346)/
	  //  3. Used in Rdio URLs like /track/We_Up_(Album_Version_(Edited))/
	  twttr.txt.regexen.validUrlBalancedParens = regexSupplant('\\(' + '(?:' + '#{validGeneralUrlPathChars}+' + '|' +
	  // allow one nested level of balanced parentheses
	  '(?:' + '#{validGeneralUrlPathChars}*' + '\\(' + '#{validGeneralUrlPathChars}+' + '\\)' + '#{validGeneralUrlPathChars}*' + ')' + ')' + '\\)', 'i');
	  // Valid end-of-path chracters (so /foo. does not gobble the period).
	  // 1. Allow =&# for empty URL parameters and other URL-join artifacts
	  twttr.txt.regexen.validUrlPathEndingChars = regexSupplant(/[\+\-a-z#{cyrillicLettersAndMarks}0-9=_#\/#{latinAccentChars}]|(?:#{validUrlBalancedParens})/i);
	  // Allow @ in a url, but only in the middle. Catch things like http://example.com/@user/
	  twttr.txt.regexen.validUrlPath = regexSupplant('(?:' + '(?:' + '#{validGeneralUrlPathChars}*' + '(?:#{validUrlBalancedParens}#{validGeneralUrlPathChars}*)*' + '#{validUrlPathEndingChars}' + ')|(?:@#{validGeneralUrlPathChars}+\/)' + ')', 'i');

	  twttr.txt.regexen.validUrlQueryChars = /[a-z0-9!?\*'@\(\);:&=\+\$\/%#\[\]\-_\.,~|]/i;
	  twttr.txt.regexen.validUrlQueryEndingChars = /[a-z0-9_&=#\/]/i;
	  twttr.txt.regexen.extractUrl = regexSupplant('(' + // $1 total match
	  '(#{validUrlPrecedingChars})' + // $2 Preceeding chracter
	  '(' + // $3 URL
	  '(https?:\\/\\/)?' + // $4 Protocol (optional)
	  '(#{validDomain})' + // $5 Domain(s)
	  '(?::(#{validPortNumber}))?' + // $6 Port number (optional)
	  '(\\/#{validUrlPath}*)?' + // $7 URL Path
	  '(\\?#{validUrlQueryChars}*#{validUrlQueryEndingChars})?' + // $8 Query String
	  ')' + ')', 'gi');

	  if (typeof window != 'undefined') {
	    if (window.twttr) {
	      for (var prop in twttr) {
	        window.twttr[prop] = twttr[prop];
	      }
	    } else {
	      window.twttr = twttr;
	    }
	  }
	})();

	exports["default"] = twttr.txt;
	module.exports = exports["default"];

/***/ }),
/* 7 */
/***/ (function(module, exports) {

	"use strict";

	exports.__esModule = true;

	function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

	var LinkedListItem = function LinkedListItem(value, next) {
	    _classCallCheck(this, LinkedListItem);

	    this.value = value;
	    this.next = next;
	};

	var MarkedIndex = function MarkedIndex(index, classes) {
	    _classCallCheck(this, MarkedIndex);

	    this.index = index || 0;
	    this.classes = classes || [];
	};

	var MarkedRange = function MarkedRange(start, end, classes) {
	    _classCallCheck(this, MarkedRange);

	    this.start = start;
	    this.end = end;
	    this.classes = classes;
	};

	var MarkedRanges = (function () {
	    function MarkedRanges() {
	        _classCallCheck(this, MarkedRanges);

	        this.list = undefined;
	    }

	    MarkedRanges.prototype.markRange = function markRange(startIndex, endIndex, className) {
	        var item = this.list,
	            prev,
	            mi,
	            classes,
	            newItem;
	        if (!item) {
	            // first mark for the text
	            mi = new MarkedIndex(startIndex, [className]);
	            this.list = new LinkedListItem(mi);
	            mi = new MarkedIndex(endIndex);
	            this.list.next = new LinkedListItem(mi);
	            return;
	        }
	        while (item && item.value.index < startIndex) {
	            prev = item;
	            item = item.next;
	        }
	        if (item && item.value.index === startIndex) {
	            item.value.classes.push(className);
	            prev = item;
	            item = item.next;
	        } else {
	            if (prev) {
	                classes = prev.value.classes.slice();
	                classes.push(className);
	            } else {
	                classes = [className];
	            }
	            mi = new MarkedIndex(startIndex, classes);
	            newItem = new LinkedListItem(mi, item);
	            if (prev) {
	                prev.next = newItem;
	            } else {
	                // have a new head of the list
	                this.list = newItem;
	            }
	            prev = newItem;
	            newItem = undefined;
	        }
	        while (item && item.value.index < endIndex) {
	            item.value.classes.push(className);
	            prev = item;
	            item = item.next;
	        }
	        if (item && item.value.index === endIndex) {
	            return;
	        }
	        if (prev) {
	            // base the classes that are valid at startIndex on
	            // the prev classes
	            classes = prev.value.classes.slice();
	            // get rid of the `className` that was added to the end
	            classes.pop();
	        } else {
	            classes = [];
	        }
	        mi = new MarkedIndex(endIndex, classes);
	        newItem = new LinkedListItem(mi, item);
	        if (prev) {
	            prev.next = newItem;
	        }
	    };

	    MarkedRanges.prototype.getRanges = function getRanges() {
	        var ranges = [],
	            item = this.list,
	            start,
	            end,
	            classes;
	        if (!item) {
	            return ranges;
	        }
	        // can skip creating a range off the last index bc it's just
	        // a stop - it has an empty classes array and doesn't need
	        // a range
	        while (item.next) {
	            classes = item.value.classes;
	            if (!classes.length) {
	                item = item.next;
	                continue;
	            }
	            start = item.value.index;
	            end = item.next.value.index;
	            item = item.next;
	            ranges.push(new MarkedRange(start, end, classes));
	        }
	        return ranges;
	    };

	    MarkedRanges.prototype.reset = function reset() {
	        this.list = undefined;
	    };

	    return MarkedRanges;
	})();

	exports["default"] = MarkedRanges;
	module.exports = exports["default"];

/***/ }),
/* 8 */
/***/ (function(module, exports, __webpack_require__) {

	'use strict';

	exports.__esModule = true;

	var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

	var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

	function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

	function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

	var _react = __webpack_require__(13);

	var _react2 = _interopRequireDefault(_react);

	var _propTypes = __webpack_require__(11);

	var _propTypes2 = _interopRequireDefault(_propTypes);

	var _MarkedRanges = __webpack_require__(7);

	var _MarkedRanges2 = _interopRequireDefault(_MarkedRanges);

	var _markers = __webpack_require__(1);

	var _presets = __webpack_require__(9);

	var _strings = __webpack_require__(2);

	var _utils = __webpack_require__(4);

	var _validators = __webpack_require__(5);

	var noOp = function noOp() {};

	var warnFn = (console.error || console.warn || console.log || function () {}).bind(console);

	var getPatternValidator = (function () {
	    var cache = {};
	    function getPatternValidator(value) {
	        if (value in cache) {
	            return cache[value];
	        }
	        var rx = undefined;
	        try {
	            rx = new RegExp(value);
	        } catch (error) {
	            warnFn('Invalid pattern regex: ' + error + '\n' + error.stack);
	            return;
	        }
	        return cache[value] = _validators.makeValidators({ pattern: rx });
	    }
	    return getPatternValidator;
	})();

	var classNames = {
	    email: 'txr-email',
	    nonDigits: 'txr-non-digit txr-invalid',
	    nonEmail: 'txr-non-email txr-invalid',
	    nonInt: 'txr-non-int txr-invalid',
	    nonNumeric: 'txr-non-numeric txr-invalid',
	    nonUint: 'txr-non-uint txr-invalid',
	    nonUrl: 'txr-non-url txr-invalid',
	    tooLong: 'txr-too-long txr-invalid',
	    url: 'txr-url'
	};

	exports.classNames = classNames;

	var TxRegionsInput = (function (_Component) {
	    _inherits(TxRegionsInput, _Component);

	    TxRegionsInput.getDerivedStateFromProps = function getDerivedStateFromProps(props, state) {
	        if (!('value' in props) || state.raw === props.value) {
	            return null;
	        }
	        return { raw: props.value == null ? '' : String(props.value) };
	    };

	    function TxRegionsInput(props) {
	        _classCallCheck(this, TxRegionsInput);

	        _Component.call(this, props);
	        var initialValue = props.defaultValue || props.value || '',
	            validators = _presets.combineValidators(props.validators, props.preset);
	        this.state = {
	            clean: '',
	            cleanCaretPos: 0,
	            hasFocus: false,
	            raw: initialValue,
	            rawCaretPos: 0
	        };

	        this._valueHistory = [initialValue];
	        this._caretHistory = [0];
	        this._historyPos = 0;
	        this._wrapper = undefined;
	        this._elm = undefined;
	        this._input = undefined;
	        // for checking if the content has changed
	        this._txContent = undefined;
	        // track number of descendants bc <enter> causes <div><br></div>
	        // to be inserted on [contenteditable] elements but does not affect
	        // the `textContent` of the [contenteditable] element
	        this._numDescendants = undefined;
	        this._marker = new _MarkedRanges2['default']();
	        this._markFn = [this._marker.markRange.bind(this._marker)];
	        // ux state related properties
	        this._uxInitialValue = initialValue;
	        this._uxValueChanged = false;
	        this._uxHadFocus = false;
	        // validity related
	        if (validators) {
	            this._validators = _validators.makeValidators(validators, props.invalidClassName);
	        } else {
	            this._validators = undefined;
	        }
	        this._violations = undefined;
	        // cache the foldWhitespace processing of state.raw
	        this._cleanCacheSrc = undefined;
	        this._cleanCacheValue = undefined;
	    }

	    TxRegionsInput.prototype._stepBackInHistory = function _stepBackInHistory() {
	        var max = this._valueHistory.length - 1,
	            raw = this.state.raw,
	            caret = this.state.rawCaretPos;
	        var r, c;
	        while (this._historyPos < max) {
	            this._historyPos++;
	            r = this._valueHistory[this._historyPos];
	            c = this._caretHistory[this._historyPos];
	            if (r !== raw || c !== caret) {
	                this._setRaw(r, c, true);
	                return;
	            }
	        }
	    };

	    TxRegionsInput.prototype._stepForwardInHistory = function _stepForwardInHistory() {
	        var raw = this.state.raw,
	            caret = this.state.rawCaretPos;
	        var r, c;
	        while (this._historyPos > 0) {
	            this._historyPos--;
	            r = this._valueHistory[this._historyPos];
	            c = this._caretHistory[this._historyPos];
	            if (r !== raw || c !== caret) {
	                this._setRaw(r, c, true);
	                return;
	            }
	        }
	    };

	    TxRegionsInput.prototype._addToHistory = function _addToHistory(value, caret) {
	        var maxHistory = +this.props.maxHistory;
	        if (this._historyPos) {
	            // have already stepped back in history, so need to clear
	            // a bit of history before adding to the history
	            this._valueHistory.splice(0, this._historyPos);
	            this._caretHistory.splice(0, this._historyPos);
	            this._historyPos = 0;
	        }
	        this._valueHistory.unshift(value);
	        this._caretHistory.unshift(caret);
	        if (maxHistory && this._valueHistory.length > maxHistory) {
	            this._valueHistory.length = maxHistory;
	            this._caretHistory.length = maxHistory;
	        }
	    };

	    TxRegionsInput.prototype._updateViolations = function _updateViolations(markRange) {
	        var clean = this.clean,
	            max = +this.props.maxLength,
	            min = +this.props.minLength,
	            pattern = this.props.pattern,
	            isRequired = !!this.props.required,
	            shouldMark = !('markInvalid' in this.props) || !!this.props.markInvalid ? true : undefined,
	            invalidClassName = this.props.invalidClassName || _validators.validatorDefaults.className;

	        var value = this._validators ? this._validators.exec(clean, shouldMark && markRange) : '';

	        if (max && max > 0 && clean.length > max) {
	            value += ' maxLength';
	            if (shouldMark && markRange) {
	                markRange(max, clean.length, invalidClassName);
	            }
	        }
	        if (clean.length && min && min > 0 && min > clean.length) {
	            value += ' minLength';
	            if (shouldMark && markRange) {
	                markRange(0, clean.length, invalidClassName);
	            }
	        }
	        if (pattern) {
	            var patternValidator = getPatternValidator(pattern);
	            if (patternValidator) {
	                var patternViolation = patternValidator.exec(clean, shouldMark && markRange);
	                if (patternViolation) {
	                    value += ' ' + patternViolation;
	                }
	            }
	        }
	        if (isRequired && !clean) {
	            value += ' required';
	        }
	        this._violations = value;
	    };

	    TxRegionsInput.prototype._setRaw = function _setRaw(value, caret, focus) {
	        if (this.props.onRawChange) {
	            this.props.onRawChange({
	                caret: caret,
	                raw: value
	            });
	        }
	        if (!('value' in this.props)) {
	            this.setState({
	                hasFocus: focus,
	                raw: value,
	                rawCaretPos: caret
	            });
	        } else if (!('caret' in this.props)) {
	            this.setState({
	                hasFocus: focus,
	                rawCaretPos: caret
	            });
	        }
	    };

	    TxRegionsInput.prototype._findSelectionOffset = function _findSelectionOffset() {
	        var sel = document.getSelection(),
	            rng = sel.rangeCount && sel.getRangeAt(0),
	            node = rng && rng.endContainer,
	            offset = rng && rng.endOffset;

	        if (!rng) {
	            return undefined;
	        }

	        if (!this._elm.contains(node)) {
	            return 0;
	        }
	        while (node !== this._elm) {
	            while (node.previousSibling) {
	                node = node.previousSibling;
	                if (node.nodeType === Node.ELEMENT_NODE || node.nodeType === Node.TEXT_NODE) {
	                    offset += node.textContent.length;
	                }
	            }
	            node = node.parentNode;
	        }
	        return offset;
	    };

	    TxRegionsInput.prototype._setSelection = function _setSelection() {
	        var sel = document.getSelection(),
	            str = this.state.raw.slice(0, this.state.rawCaretPos),
	            cleanCaretPos = _strings.foldWhitespace(str).length,
	            range = _utils.makeSelectionRange(this._elm, cleanCaretPos);

	        if (!range) {
	            range = document.createRange();
	            range.selectNodeContents(this._elm);
	            range.collapse(false);
	        }
	        sel.removeAllRanges();
	        sel.addRange(range);
	    };

	    TxRegionsInput.prototype._forceHtml = function _forceHtml() {
	        var clean = this.clean,
	            markFn = this._markFn[0];

	        var markers = this.props.markers,
	            i = undefined,
	            ci = undefined,
	            rng = undefined,
	            tx = undefined,
	            span = undefined,
	            rngClasses = undefined;

	        this._elm.innerHTML = '';
	        if (!clean) {
	            this._txContent = this._elm.textContent;
	            this._numDescendants = this._elm.childNodes.length;
	            return '';
	        }
	        this._marker.reset();
	        if (typeof markers === 'function') {
	            markers = [markers];
	            i = 1;
	        } else {
	            i = markers ? markers.length : 0;
	        }
	        while (i--) {
	            markers[i](clean, markFn, this, classNames);
	        }
	        // process the violations -- pass the marker function so the validators
	        // can (optionally) mark the invalid text
	        this._updateViolations(markFn);

	        var ranges = this._marker.getRanges(),
	            rmax = ranges.length,
	            frag = document.createDocumentFragment();

	        i = 0;
	        ci = 0;
	        for (; i < rmax; i++) {
	            rng = ranges[i];
	            if (rng.start > ci) {
	                tx = document.createTextNode(clean.slice(ci, rng.start));
	                frag.appendChild(tx);
	            }
	            span = document.createElement('span');
	            rngClasses = rng.classes.join(' ').split(/\s+/g);
	            span.classList.add.apply(span.classList, rngClasses);
	            span.textContent = clean.slice(rng.start, rng.end);
	            frag.appendChild(span);
	            ci = rng.end;
	        }
	        if (ci < clean.length) {
	            tx = document.createTextNode(clean.slice(ci));
	            frag.appendChild(tx);
	        }

	        this._elm.appendChild(frag);
	        this._txContent = this._elm.textContent;
	        this._numDescendants = this._elm.querySelectorAll('*').length;
	        // set the violations
	        if (this._violations) {
	            this._wrapper.setAttribute('data-violations', this._violations);
	        } else {
	            this._wrapper.removeAttribute('data-violations');
	        }
	    };

	    TxRegionsInput.prototype._emitUpdate = function _emitUpdate() {
	        var data;
	        if (typeof this.props.onUpdate !== 'function') {
	            return;
	        }
	        data = {
	            clean: this.clean,
	            component: this,
	            isValid: !this._violations,
	            raw: this.state.raw,
	            violations: this._violations || undefined
	        };
	        if (this._input) {
	            data.input = this._input;
	            data.value = this._input.value;
	        }
	        this.props.onUpdate(data);
	    };

	    TxRegionsInput.prototype._handleChange = function _handleChange() {
	        // if a change occurred, note the new text and caret position
	        var raw = this._elm.textContent,
	            numDescendants = this._elm.querySelectorAll('*').length,
	            hasFocus = this._elm === document.activeElement,
	            caretPos = this._findSelectionOffset();
	        // if nothing changed, ignore this callback
	        if (raw === this._txContent && numDescendants === this._numDescendants) {
	            return;
	        }
	        this._uxValueChanged = true;
	        // reset the content back to the last known state
	        this._forceHtml();
	        if (hasFocus) {
	            this._setSelection();
	        }
	        this._setRaw(raw, caretPos, hasFocus);
	    };

	    TxRegionsInput.prototype._handleFocus = function _handleFocus() {
	        var _this = this;

	        this._uxHadFocus = true;
	        // setting the state in the onFocus handler directly clobbers the
	        // initial cursor position, so set the state asynchronously
	        setTimeout(function () {
	            _this.setState({
	                hasFocus: true,
	                rawCaretPos: _this._findSelectionOffset()
	            });
	        }, 0);
	    };

	    TxRegionsInput.prototype._handleBlur = function _handleBlur() {
	        this.setState({ hasFocus: false });
	    };

	    TxRegionsInput.prototype._handleKeyDown = function _handleKeyDown(event) {
	        if (event.keyCode === _strings.KEY_CODES.ENTER) {
	            event.preventDefault();
	            if (this.props.onEnterKeyDown) {
	                var data = {
	                    metaKey: event.metaKey,
	                    shiftKey: event.shiftKey,
	                    clean: this.clean,
	                    component: this,
	                    isValid: !this._violations,
	                    raw: this.state.raw,
	                    violations: this._violations || undefined
	                };
	                if (this._input) {
	                    data.input = this._input;
	                    data.value = this._input.value;
	                }
	                this.props.onEnterKeyDown(data);
	            }
	        } else if (event.metaKey && event.keyCode === _strings.KEY_CODES.Z) {
	            event.preventDefault();
	            this._isUndo = true;
	            if (event.shiftKey) {
	                this._stepForwardInHistory();
	            } else {
	                this._stepBackInHistory();
	            }
	        }
	    };

	    TxRegionsInput.prototype.componentDidMount = function componentDidMount() {
	        this._uxInitialValue = this.props.defaultValue || this.props.value || '';
	        this.setState({
	            raw: this._uxInitialValue,
	            rawCaretPos: 0
	        });
	        if (this._input) {
	            this._input.value = this._uxInitialValue;
	        }
	        this._forceHtml();
	        if (this._input) {
	            // mark the input as `:invalid` if there are violations
	            this._input.setCustomValidity(this._violations || '');
	        }
	        this._emitUpdate();
	    };

	    TxRegionsInput.prototype.shouldComponentUpdate = function shouldComponentUpdate(nextProps, nextState) {
	        return nextState.hasFocus !== this.state.hasFocus || nextState.raw !== this.state.raw || nextState.rawCaretPos !== this.state.rawCaretPos || !!this.props.dynamicMarkers && this.props.markers !== nextProps.markers;
	    };

	    TxRegionsInput.prototype.componentDidUpdate = function componentDidUpdate() {
	        this._forceHtml();

	        if (this.state.hasFocus && this.state.rawCaretPos != null) {
	            this._setSelection();
	        }
	        if (this._isUndo) {
	            this._isUndo = false;
	        } else {
	            this._addToHistory(this.state.raw, this.state.hasFocus ? this.state.rawCaretPos : this.state.raw.length);
	        }
	        if (this._input) {
	            // mark the input as `:invalid` if there are violations
	            this._input.setCustomValidity(this._violations || '');
	        }
	        this._emitUpdate();
	    };

	    TxRegionsInput.prototype.render = function render() {
	        var _this2 = this;

	        this._updateViolations();

	        var p = this.props,
	            clean = this.clean,
	            editableProps = p.setEditableProps || {},
	            wrapperProps = p.setWrapperProps || {},
	            violations = this._violations ? { 'data-violations': this._violations } : {};

	        editableProps.contentEditable = true;

	        var uxFocus = undefined,
	            uxChanged = undefined,
	            input = undefined,
	            inputProps = undefined;

	        uxChanged = this._uxValueChanged ? 'changed-done' : 'changed-never';
	        if (this.state.hasFocus) {
	            uxFocus = 'focus-now ';
	        } else if (this._uxHadFocus) {
	            uxFocus = 'focus-had ';
	        } else {
	            uxFocus = 'focus-never ';
	        }

	        if (p.input) {
	            inputProps = p.setInputProps || {};
	            input =
	            // Use input type="text" so can still manage the validity
	            // (`:invalid`) manually (type="hidden" ignore custom validity).
	            // The `hidden` attribute takes care of making it invisible. Use
	            // a `noOp` onChange handler to get rid of the react warning.
	            _react2['default'].createElement('input', _extends({
	                ref: function (elm) {
	                    return _this2._input = elm;
	                },
	                hidden: true,
	                type: 'text',
	                onChange: noOp,
	                name: typeof p.input === 'string' ? p.input : '',
	                value: clean.trim()
	            }, inputProps));
	        }
	        return _react2['default'].createElement(
	            'div',
	            _extends({
	                ref: function (elm) {
	                    return _this2._wrapper = elm;
	                }
	            }, wrapperProps, violations, {
	                'data-ux-state': uxFocus + uxChanged
	            }),
	            input,
	            _react2['default'].createElement('div', _extends({
	                ref: function (elm) {
	                    return _this2._elm = elm;
	                },
	                onBlur: this._handleBlur.bind(this),
	                onFocus: this._handleFocus.bind(this),
	                onInput: this._handleChange.bind(this),
	                onKeyDown: this._handleKeyDown.bind(this),
	                'data-placeholder': clean ? '' : p.placeholder,
	                spellCheck: p.spellCheck
	            }, editableProps)),
	            p.children
	        );
	    };

	    _createClass(TxRegionsInput, [{
	        key: 'clean',
	        get: function get() {
	            if (this.state.raw === this._cleanCacheSrc) {
	                return this._cleanCacheValue;
	            }
	            this._cleanCacheSrc = this.state.raw;
	            return this._cleanCacheValue = _strings.foldWhitespace(this._cleanCacheSrc);
	        }
	    }, {
	        key: 'raw',
	        get: function get() {
	            return this.state.raw;
	        }
	    }]);

	    return TxRegionsInput;
	})(_react.Component);

	exports['default'] = TxRegionsInput;

	TxRegionsInput.propTypes = {
	    defaultValue: _propTypes2['default'].string,
	    dynamicMarkers: _propTypes2['default'].bool,
	    input: _propTypes2['default'].oneOfType([_propTypes2['default'].string, _propTypes2['default'].bool]),
	    invalidClassName: _propTypes2['default'].string,
	    markers: _propTypes2['default'].oneOfType([_propTypes2['default'].func, _propTypes2['default'].array]),
	    markInvalid: _propTypes2['default'].bool,
	    maxHistory: _utils.positiveNumericPropCheck,
	    maxLength: _utils.positiveNumericPropCheck,
	    minLength: _utils.positiveNumericPropCheck,
	    pattern: _propTypes2['default'].string,
	    onEnterKeyDown: _propTypes2['default'].func,
	    onUpdate: _propTypes2['default'].func,
	    onRawChange: _propTypes2['default'].func,
	    placeholder: _propTypes2['default'].string,
	    required: _propTypes2['default'].bool,
	    setEditableProps: _propTypes2['default'].object,
	    setInputProps: _propTypes2['default'].object,
	    setWrapperProps: _propTypes2['default'].object,
	    spellCheck: _propTypes2['default'].bool,
	    validators: _validators.validatorsPropCheck,
	    value: _propTypes2['default'].string
	};

	TxRegionsInput.defaultProps = {
	    defaultValue: '',
	    markers: undefined,
	    maxHistory: 100,
	    placeholder: '',
	    spellCheck: false
	};

	TxRegionsInput.defaultMarkers = TxRegionsInput.defaultProps.markers;

/***/ }),
/* 9 */
/***/ (function(module, exports, __webpack_require__) {

	'use strict';

	exports.__esModule = true;
	exports.combineValidators = combineValidators;

	function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj['default'] = obj; return newObj; } }

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

	var _vendorTwitterText = __webpack_require__(6);

	var _vendorTwitterText2 = _interopRequireDefault(_vendorTwitterText);

	var _regex = __webpack_require__(3);

	var regex = _interopRequireWildcard(_regex);

	var PRESETS = {
	    // must use the non-global RegExp
	    email: regex.EMAIL,
	    // make a non-global URL RegExp
	    url: new RegExp(_vendorTwitterText2['default'].regexen.extractUrl.source, 'i'),
	    number: regex.NUMERIC_EN,
	    'number eu': regex.NUMERIC_EU,
	    int: regex.INT,
	    uint: regex.UINT
	},
	    PRESET_KEYS = '"' + Object.keys(PRESETS).join('", "') + '"';

	function combineValidators(validators, preset) {
	    var rx;
	    if (!preset) {
	        return validators;
	    }
	    rx = PRESETS[preset];
	    if (!rx) {
	        throw new Error('Invalid validator preset: ' + preset + ', must be one of ' + PRESET_KEYS);
	    } else if (!validators) {
	        return rx;
	    } else if (Array.isArray(validators)) {
	        return validators.concat([rx]);
	    } else {
	        return [validators, rx];
	    }
	}

/***/ }),
/* 10 */
/***/ (function(module, exports, __webpack_require__) {

	/**
	 * Copyright (c) 2013-present, Facebook, Inc.
	 *
	 * This source code is licensed under the MIT license found in the
	 * LICENSE file in the root directory of this source tree.
	 */

	'use strict';

	var ReactPropTypesSecret = __webpack_require__(12);

	function emptyFunction() {}
	function emptyFunctionWithReset() {}
	emptyFunctionWithReset.resetWarningCache = emptyFunction;

	module.exports = function() {
	  function shim(props, propName, componentName, location, propFullName, secret) {
	    if (secret === ReactPropTypesSecret) {
	      // It is still safe when called from React.
	      return;
	    }
	    var err = new Error(
	      'Calling PropTypes validators directly is not supported by the `prop-types` package. ' +
	      'Use PropTypes.checkPropTypes() to call them. ' +
	      'Read more at http://fb.me/use-check-prop-types'
	    );
	    err.name = 'Invariant Violation';
	    throw err;
	  };
	  shim.isRequired = shim;
	  function getShim() {
	    return shim;
	  };
	  // Important!
	  // Keep this list in sync with production version in `./factoryWithTypeCheckers.js`.
	  var ReactPropTypes = {
	    array: shim,
	    bool: shim,
	    func: shim,
	    number: shim,
	    object: shim,
	    string: shim,
	    symbol: shim,

	    any: shim,
	    arrayOf: getShim,
	    element: shim,
	    elementType: shim,
	    instanceOf: getShim,
	    node: shim,
	    objectOf: getShim,
	    oneOf: getShim,
	    oneOfType: getShim,
	    shape: getShim,
	    exact: getShim,

	    checkPropTypes: emptyFunctionWithReset,
	    resetWarningCache: emptyFunction
	  };

	  ReactPropTypes.PropTypes = ReactPropTypes;

	  return ReactPropTypes;
	};


/***/ }),
/* 11 */
/***/ (function(module, exports, __webpack_require__) {

	/**
	 * Copyright (c) 2013-present, Facebook, Inc.
	 *
	 * This source code is licensed under the MIT license found in the
	 * LICENSE file in the root directory of this source tree.
	 */

	if (false) {
	  var ReactIs = require('react-is');

	  // By explicitly using `prop-types` you are opting into new development behavior.
	  // http://fb.me/prop-types-in-prod
	  var throwOnDirectAccess = true;
	  module.exports = require('./factoryWithTypeCheckers')(ReactIs.isElement, throwOnDirectAccess);
	} else {
	  // By explicitly using `prop-types` you are opting into new production behavior.
	  // http://fb.me/prop-types-in-prod
	  module.exports = __webpack_require__(10)();
	}


/***/ }),
/* 12 */
/***/ (function(module, exports) {

	/**
	 * Copyright (c) 2013-present, Facebook, Inc.
	 *
	 * This source code is licensed under the MIT license found in the
	 * LICENSE file in the root directory of this source tree.
	 */

	'use strict';

	var ReactPropTypesSecret = 'SECRET_DO_NOT_PASS_THIS_OR_YOU_WILL_BE_FIRED';

	module.exports = ReactPropTypesSecret;


/***/ }),
/* 13 */
/***/ (function(module, exports) {

	module.exports = __WEBPACK_EXTERNAL_MODULE_13__;

/***/ })
/******/ ])
});
;